//
//  MINTLCPAbstructSource.swift
//  TextEditDoc
//
//  Created by narita on 2018/06/15.
//  Copyright © 2018年 narita. All rights reserved.
//

import Cocoa

class MINTLCPAbstructSource: NSObject
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods

    // 初期化
    @objc func launching()
    {
        
        
    }

    // 破棄
    @objc func terminate()
    {
        
    }
    
    // アクティブ --> 内容のアップデート(menu系とかwindowやviewの状態でenable/disableが異なるのでこのタイミングで更新)
    @objc func active()
    {
        
    }

    // ディアクティブ -> 別スレッドでの検索の中止や、キャッシュの放棄
    @objc func deactive()
    {
        sourceItems = []
    }
    

    @objc func sourceItems(strings: [NSString]) -> Array<MINTLCPAbstructSourceItem>
    {
        if strings == []
        {
            sourceItems.forEach()
            {
                item in

                item.mathcedString = NSAttributedString(string: item.string)
            }
            
            return sourceItems
        }
        else
        {
            let theResult = sourceItems.filter
            {
                item in
                
                strings.reduce(true)
                {
                    $0 &&  ($1 as String).regularExpressionWithIgnoreCaseMatches(string: item.string)
                }
            }

            theResult.forEach()
            {
                item in

                if let theFirstString = strings.first as String?
                {
                    let theRange = theFirstString.rangeOfFirstMatchsRegularExpressionWithIgnoreCaseMatches(string: item.string)
                    
                    let theDisplayString = NSMutableAttributedString(string: item.string)

                    
                    theDisplayString.addAttributes(
                        [NSAttributedString.Key.font : NSFont.systemFont(ofSize: NSFont.systemFontSize,
                                                                         weight: NSFont.Weight.regular)],
                        range: NSMakeRange(0, theDisplayString.length))

                    
                    theDisplayString.addAttributes(
                        [NSAttributedString.Key.font : NSFont.systemFont(ofSize: NSFont.systemFontSize,
                                                                         weight: NSFont.Weight.heavy)],
                        range: theRange)
                    
                    item.mathcedString = theDisplayString.copy() as! NSAttributedString
                }
            }

            return theResult
        }
    }
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    @objc var sourceItems: Array<MINTLCPAbstructSourceItem> = []
    
    // グループ名：NSTableViewに表示されます
    @objc open var groupDisplayName: String
    {
        return "Abstruct MINTLCPAbstructSource Group"
    }

    // kind名: kindで絞り込む時に使う文字列
    @objc open var kindString: String
    {
        return "abstruct"
    }

    @objc open var kindStringWithTag: String
    {
        return "kind:" + self.kindString
    }

    // MARK: - Utility methods

}

