//
//  MINTLCPMenuSource.swift
//  TextEditDoc
//
//  Created by narita on 2019/03/24.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

class MINTLCPMenuSource: MINTLCPAbstructSource
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods

    // 初期化
    @objc override func launching()
    {
        super.launching()
    }
    
    // 破棄
    @objc override func terminate()
    {
        super.terminate()
    }
    
    @objc override func active()
    {
        super.active()
        

        if let theMenu = NSApp.mainMenu
        {
            // メニューの中を再帰的に操作するためだけに、ここで関数定義
            func traverse(from menu: NSMenu)
            {
                menu.items.forEach()
                {
                    theMenuItem in
                    
                    if
                            theMenuItem.hasSubmenu != true
                        &&
                            theMenuItem.isSeparatorItem != true
                    {
                        sourceItems.append(
                            MINTLCPAbstructSourceItem(
                                description: theMenuItem.title,
                                action:
                                {
                                    menu.performActionForItem(at: menu.index(of: theMenuItem))
                                }
                            )
                        )
                    }
                    
                    if theMenuItem.hasSubmenu
                    {
                        if let theSubMenu = theMenuItem.submenu
                        {
                            traverse(from: theSubMenu)
                        }
                    }
                }
            }
            
            // ここでだけ実行。
            traverse(from: theMenu)
            
            // メモ：再帰的に呼び出す無名関数を作る構文があった気がしたが、名前を忘れたのでググれない。
            
        }

        
//            
//            
//            
//
//            // NSMenu.performActionForItem(at index: Int)
//
//        }
    }
    
    // ディアクティブ -> 別スレッドでの検索の中止や、キャッシュの放棄
    @objc override func deactive()
    {
        super.deactive()
    }
    

    
    // 文字列指定して、フィルタ後のリストの取得
    // 文字列が「空」の時に空配列を返すか、全部を返すかはそれぞれのサブクラスが決める。
    // 履歴機能の場合は、空であっても配列を返して、
    
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    @objc override var groupDisplayName: String
    {
        return NSLocalizedString("Menu", comment: "Menu")
    }

    // kind名: kindで絞り込む時に使う文字列
    @objc override var kindString: String
    {
        return "menu"
    }
}
