//
//  MINTLCPPanel.swift
//  TextEditDoc
//
//  Created by narita on 2018/06/08.
//  Copyright © 2018年 narita. All rights reserved.
//

import Cocoa

class MINTLCPPanel: NSPanel
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    override init(contentRect: NSRect,
                  styleMask style: NSWindow.StyleMask,
                  backing backingStoreType: NSWindow.BackingStoreType,
                  defer flag: Bool)
    {
        super.init(contentRect: contentRect,
                   styleMask: NSWindow.StyleMask(rawValue: style.rawValue | NSWindow.StyleMask.borderless.rawValue),
                   backing: backingStoreType,
                   defer: flag)
        
        self.hasShadow = true
        self.backgroundColor = NSColor.clear
        self.isOpaque = false
    }
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    @IBAction override func cancelOperation(_ sender : Any?)
    {
        self.manager?.deactive( nil)
    }

    // MARK: - event handling methods
    
    override func performKeyEquivalent(with event: NSEvent) -> Bool
    {
        // ここで、キーイベントのハックをしても良い....?
        return super.performKeyEquivalent(with: event)
    }

    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    override var canBecomeKey: Bool
    {
        return true
    }

    override var canBecomeMain: Bool
    {
        return false
    }

    @objc open var manager: MINTLCPManager?
    {
        return MINTLCPManager.shared
    }

    @objc class func keyPathsForValuesAffectingPanelController() -> Set<String>
    {
        return [ "windowController" ]
    }
    
    @objc open var panelController: MINTLCPPanelController?
    {
        return self.windowController as? MINTLCPPanelController
    }

    @objc class func keyPathsForValuesAffectingViewController() -> Set<String>
    {
        return [ "contentViewController" ]
    }
    
    @objc open var viewController: MINTLCPViewController?
    {
        return self.contentViewController as? MINTLCPViewController
    }
    
    // MARK: - Utility methods

}
