//
//  MINTLCPPanelController.swift
//  TextEditDoc
//
//  Created by narita on 2018/06/08.
//  Copyright © 2018年 narita. All rights reserved.
//

import Cocoa

class MINTLCPPanelController: NSWindowController, NSWindowDelegate
{
    // MARK: - class methods

    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    override func windowDidLoad()
    {
        super.windowDidLoad()
    }
    
    func windowDidBecomeKey(_ notification: Notification)
    {
        self.manager?.active(nil)
    }
    
    func windowDidResignKey(_ notification: Notification)
    {
        self.manager?.deactive(nil)
    }
    
    // MARK: - action methods
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    @objc open var manager: MINTLCPManager?
    {
        return MINTLCPManager.shared
    }
    
    @objc class func keyPathsForValuesAffectingViewController() -> Set<String>
    {
        return [ "contentViewController" ]
    }
    
    @objc open var viewController: MINTLCPViewController?
    {
        return self.contentViewController as? MINTLCPViewController
    }
    
    @objc class func keyPathsForValuesAffectingpanel() -> Set<String>
    {
        return [ "window" ]
    }
    
    @objc open var panel: MINTLCPPanel?
    {
        return self.window as? MINTLCPPanel
    }
    
    // MARK: - Utility methods
    
    // main screenの中央(2/3)にpanelを移動
    func relayoutPanelPosition()
    {
        let theMainWindowFrame = NSScreen.main!.frame
        let theSelfWindowFrame = self.window!.frame
        
        let theDeltaX = (theMainWindowFrame.size.width - theSelfWindowFrame.size.width) / 2
        let theDeltaY = (theMainWindowFrame.size.height - theSelfWindowFrame.size.height) / (1.5)
        
        var theNewFrame: NSRect = theMainWindowFrame
        
        theNewFrame.origin.x += theDeltaX
        theNewFrame.origin.y += theDeltaY
        
        theNewFrame.size   = theSelfWindowFrame.size
        
        self.window?.setFrame(theNewFrame, display: true)
    }

}
