//
//  MINTLCPRecentDocumentSource.swift
//  TextEditDoc
//
//  Created by narita on 2019/03/24.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

class MINTLCPRecentDocumentSource: MINTLCPAbstructSource
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods

    // 初期化
    @objc override func launching()
    {
        super.launching()
    }
    
    // 破棄
    @objc override func terminate()
    {
        super.terminate()
    }
    
    @objc override func active()
    {
        super.active()
        
        NSDocumentController.shared.recentDocumentURLs.forEach()
        {
            let theName: String = $0.isFileURL ?  $0.lastPathComponent : $0.relativeString
            
            let theURL = $0 as URL

            sourceItems.append(MINTLCPAbstructSourceItem(
                description:theName,
                action:
                {
                    NSDocumentController.shared.openDocument(withContentsOf: theURL,
                                                             display: true,
                                                             completionHandler: {
                                                                (_, _, _) in
                                                                
                                                                })
                }
            ))
        }
    }
    
    // ディアクティブ -> 別スレッドでの検索の中止や、キャッシュの放棄
    @objc override func deactive()
    {
        super.deactive()
    }
        
    // 文字列指定して、フィルタ後のリストの取得
    // 文字列が「空」の時に空配列を返すか、全部を返すかはそれぞれのサブクラスが決める。
    // 履歴機能の場合は、空であっても配列を返して、
    
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    @objc override var groupDisplayName: String
    {
        return NSLocalizedString("Recent Documents", comment: "Recent Documents")
    }

    @objc override var kindString: String
    {
        return "recent"
    }
}
