//
//  MINTLCPRoundedCornersView.swift
//  TextEditDoc
//
//  Created by narita on 2019/03/19.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

class MINTLCPRoundedCornersView: NSView
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    // MARK: - action methods
    
    // MARK: - event handling methods
    
    @objc override func mouseDown(with event: NSEvent)
    {
        self.mouseDownPoint = event.locationInWindow
        super.mouseDown(with: event)
    }
    
    @objc override func mouseDragged(with event: NSEvent)
    {
        if let theWindow = self.window
        {
            let theCurrentLocation = theWindow.convertPoint(
                                                toScreen: theWindow.mouseLocationOutsideOfEventStream)
            
            let theNewOrigin = NSPoint( x: theCurrentLocation.x - self.mouseDownPoint.x,
                                              y: theCurrentLocation.y - self.mouseDownPoint.y)
            
            theWindow.setFrameOrigin(theNewOrigin)
        }

        super.mouseDragged(with: event)
    }
    
    // MARK: - drawing methods

    override func draw(_ dirtyRect: NSRect)
    {
        super.draw(dirtyRect)

        let thePath = NSBezierPath(roundedRect: self.bounds,
                                   xRadius: self.cornerRadius,
                                   yRadius: self.cornerRadius)
        
        NSColor.windowBackgroundColor.setFill()
        
        thePath.fill()
    }

    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)

    @IBInspectable @objc var cornerRadius: CGFloat = 5.0
    
    @objc var mouseDownPoint: NSPoint = NSPoint(x:0, y:0)
    
    // MARK: - Utility methods

}
