//
//  MINTLCPTextField.swift
//  TextEditDoc
//
//  Created by narita on 2019/03/24.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

// PlaceHolder風の文字列を入力中も表示する。
//

class MINTLCPTextField: NSTextField
{
    // MARK: - class methods
 
    class func cellClass() -> AnyClass?
    {
        return MINTLCPTextFieldCell.self
    }

    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // MARK: - event handling methods
    
    override func textDidChange(_ notification: Notification)
    {
        super.textDidChange(notification)
        
        if let theCell = self.cell as? MINTLCPTextFieldCell
        {
            theCell.textDidChange(notification)
        }
    }

    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)

    @objc var suggestionString: String?
    {
        set(newValue)
        {
            if let theCell = self.cell as? MINTLCPTextFieldCell
            {
                theCell.suggestionString = newValue
            }
        }
        
        get
        {
            if let theCell = self.cell as? MINTLCPTextFieldCell
            {
                return theCell.suggestionString
            }
        
            return nil
        }
    }
    
    // MARK: - Utility methods

}

class MINTLCPTextFieldCell: NSTextFieldCell
{
    // MARK: - class methods

    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // MARK: - event handling methods
    
    // 強制的に値をupdateさせる
    func textDidChange(_ notification: Notification)
    {
        if let theCntrol = self.controlView as? NSTextField
        {
            _ = theCntrol.stringValue
        }
    }

    // MARK: - drawing methods
    
    override func drawInterior(withFrame cellFrame: NSRect, in controlView: NSView)
    {
        super.drawInterior(withFrame: cellFrame, in: controlView)
        
        if let theFont = self.font
        {
            var theDrawingRect = self.drawingRect(forBounds: cellFrame)
            theDrawingRect.origin.x += 2 // 補正値
            
            let theStyle = NSMutableParagraphStyle()
            theStyle.alignment = self.alignment
            
            if let theString = self.suggestionString
            {
                // 何もない時は、placeHolderを表示させる
                if let theControl = self.controlView as? NSTextField
                {
                    if theControl.stringValue != ""
                    {
                        theString.draw(in: theDrawingRect,
                                       withAttributes: [
                                        NSAttributedString.Key.paragraphStyle: theStyle,
                                        NSAttributedString.Key.foregroundColor: NSColor.placeholderTextColor,
                                        NSAttributedString.Key.font : theFont])
                    }

                }
            }
            
        }
    }

    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)

    @objc var suggestionString: String? = ""
    
    //  バックグラウンドカラーを絶対に描画させないため
    override var drawsBackground: Bool
    {
        get
        {
            return false
        }
        
        set(newValue)
        {
            
        }
    }

    // MARK: - Utility methods

}
