//
//  MINTLCPViewController.swift
//  TextEditDoc
//
//  Created by narita on 2018/06/08.
//  Copyright © 2018年 narita. All rights reserved.
//

import Cocoa

class MINTLCPViewController: NSViewController, NSTextFieldDelegate, NSTableViewDelegate
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
    }
    
    override func viewWillAppear()
    {
        super.viewWillAppear()
        
        // アクティブになったら、first Responder になっておく。
        self.textFiled?.becomeFirstResponder()
        self.textFiled?.placeholderString = "Command pallete"
//        self.textFiled?.suggestionString = "suggestions"
        
        // 初期化処理
        self.manager?.keyEvent(nil)
        
        // 最初の項目を選択する
        self.listView?.selectRowIndexes(IndexSet(integer: 1), byExtendingSelection: false)
        
        if let theRowView = self.listView!.rowView(atRow: self.listView!.selectedRow, makeIfNecessary: false)
        {
            theRowView.isEmphasized = true
        }


    }
    
    
    // MARK: - action methods
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods

    // MARK: - NSTextFieldDelegate methods

    @objc  func controlTextDidChange(_ obj: Notification)
    {
        // 最初の項目を選択する
        self.listView?.selectRowIndexes(IndexSet(integer: 1), byExtendingSelection: false)
    }

    
    @objc func control(_ control: NSControl, textView: NSTextView, doCommandBy commandSelector: Selector) -> Bool
    {
        if
                commandSelector == #selector(moveUp)
            ||
                commandSelector == #selector(moveDown)
            ||
                commandSelector == #selector(pageDown)
            ||
                commandSelector == #selector(pageUp)
            ||
                commandSelector == #selector(insertTab)
            ||
                commandSelector == #selector(complete)
            ||
                commandSelector == #selector(insertNewline)
            ||
                commandSelector == #selector(insertNewlineIgnoringFieldEditor)
        {
            self.perform(commandSelector, with: nil)
            return true
        }

        return false
    }
    
    @IBAction override func cancelOperation(_ sender : Any?)
    {
        if let theTextFiled = self.textFiled
        {
            if theTextFiled.stringValue != ""
            {
                theTextFiled.stringValue = ""
            }
            else
            {
                self.panelController?.close()
            }
        }
    }
    
    // 上下キーやTabキーの場合は別の処理を行う

    @objc override func moveUp(_ sender: Any?)
    {
        if let theArrayController = self.arrayController
        {
            theArrayController.selectPrevious(nil)
            
            DispatchQueue.main.async()
            {
                self.listView?.scrollRowToVisible(theArrayController.selectionIndex)
            }
        }
    }

    @objc override func moveDown(_ sender: Any?)
    {
        if let theArrayController = self.arrayController
        {
            theArrayController.selectNext(nil)

            DispatchQueue.main.async()
            {
                self.listView?.scrollRowToVisible(theArrayController.selectionIndex)
            }
        }
    }
    
    
    @objc override func pageUp(_ sender: Any?)
    {
        // 今の位置から、indexを減らしてゆき最初に見つかったgroupを選択する。なければ何もしない。
        if let theArray = self.arrayController!.arrangedObjects as? NSArray
        {
            let theIndex = self.arrayController!.selectionIndex
            
            if theIndex != -1
            {
                for i in stride(from: theIndex - 1, to: -1, by: -1)
                {
                    if let item = theArray[i] as? MINTLCPAbstructSourceItem
                    {
                        if item.isGroup
                        {
                            // 最初の項目を選択する
                            self.listView?.selectRowIndexes(IndexSet(integer: i), byExtendingSelection: false)

                            DispatchQueue.main.async()
                            {
                                self.listView?.scrollRowToVisible(i)
                            }

                            break
                        }
                    }
                }
            }
        }
    }
    
    
    @objc override func pageDown(_ sender: Any?)
    {
        // 今の位置から、indexを増やしてゆき、最初に見つかったgroupを選択する。なければ何もしない。
        if let theArray = self.arrayController!.arrangedObjects as? NSArray
        {
            let theIndex = self.arrayController!.selectionIndex
            
            if theIndex != -1
            {
                for i in stride(from: theIndex + 1, to: theArray.count, by: 1)
                {
                    if let item = theArray[i] as? MINTLCPAbstructSourceItem
                    {
                        if item.isGroup
                        {
                            // 最初の項目を選択する
                            self.listView?.selectRowIndexes(IndexSet(integer: i), byExtendingSelection: false)
                            
                            DispatchQueue.main.async()
                            {
                                    self.listView?.scrollRowToVisible(i)
                            }
                            
                            break
                        }
                    }
                }
            }
        }

        
    }
    
    @objc override func insertTab(_ sender: Any?)
    {
        // 入力文字列を補完できるところまで補完する
        print("insertTab")
        
        
        
        
    }

    @objc override func complete(_ sender: Any?)
    {
        // 入力文字列を補完できるところまで補完する
        print("complete")
    }

    
    
    @IBAction @objc override func insertNewline(_ sender: Any?)
    {
        if let theArray = self.arrayController!.arrangedObjects as? NSArray
        {
            let theIndex = self.arrayController!.selectionIndex
            
            if theIndex != -1
            {
                if let theItem = theArray[theIndex] as? MINTLCPAbstructSourceItem
                {
                    theItem.performAction()
                }
            }
        }
    }

    @objc override func insertNewlineIgnoringFieldEditor(_ sender: Any?)
    {
        self.insertNewline(sender)
    }


    // MARK: - NSTableViewDelegate methods

    @objc func tableView(_ tableView: NSTableView, viewFor tableColumn: NSTableColumn?, row: Int) -> NSView?
    {
        if tableView == self.listView
        {
            if tableColumn == nil
            {
                // gropuはhiddenにしてある、TableColumから取ってくる
                if let theResult = tableView.makeView(withIdentifier: NSUserInterfaceItemIdentifier("group"),
                                                   owner: self) as? NSTableCellView
                {
                    return theResult
                }
            }
            else
            {
                if let theResult = tableView.makeView(withIdentifier: tableColumn!.identifier,
                                                              owner: self) as? NSTableCellView
                {
                    if
                        let theArray = self.arrayController!.arrangedObjects as? NSArray,
                        let theItem = theArray.object(at: row) as? MINTLCPAbstructSourceItem
                    {
                        theResult.subviews.forEach()
                        {
                            $0.removeFromSuperview()
                        }
                        
                        if theResult.textField == nil
                        {
                            let theNewLabel = NSTextField.init(labelWithAttributedString: theItem.displayString)
                            theResult.addSubview(theNewLabel)
                            theNewLabel.frame = NSMakeRect(1, 0, 465, 17)
                        }                        
                    }
                    
                    return theResult
                }
            }
        }

        return nil
    }
    
    @objc func tableViewSelectionDidChange(_ notification: Notification)
    {
        if let tableView = self.listView
        {
            if  tableView.selectedRow != -1
            {
                if let theRowView = tableView.rowView(atRow: tableView.selectedRow, makeIfNecessary: false)
                {
                    theRowView.isEmphasized = true
                }
                else
                {
                }
            }
        }
    }
    

//    // Groupの行を選択させないため　やっぱり選択させる
//    @objc func tableView(_ tableView: NSTableView, shouldSelectRow: Int) -> Bool
//    {
//        if tableView == self.listView
//        {
//            // NSArrayControllerからEntryを取り出してgroupかどうかを調べる
//            if let theArray = self.arrayController!.arrangedObjects as? NSArray
//            {
//                if let theItem = theArray[shouldSelectRow] as? MINTLCPAbstructSourceItem
//                {
//                    return !theItem.isGroup
//                }
//            }
//        }
//        
//        return true
//    }
    
    // グループの行をGUIへ教える
    @objc func tableView(_ tableView: NSTableView, isGroupRow row: Int) -> Bool
    {
        if tableView == self.listView
        {
            // NSArrayControllerからEntryを取り出してgroupかどうかを調べる
            if let theArray = self.arrayController!.arrangedObjects as? NSArray
            {
                if let theItem = theArray[row] as? MINTLCPAbstructSourceItem
                {
                    return theItem.isGroup
                }
            }
        }

        return false
    }
    
    // MARK: - accessor methods (in pairs)
    
    @IBOutlet var textFiled: MINTLCPTextField? = nil
    
    @IBOutlet var listView: NSTableView? = nil
   
    @IBOutlet var arrayController: NSArrayController? = nil
    
    @objc var manager: MINTLCPManager?
    {
        return MINTLCPManager.shared
    }

    @objc class func keyPathsForValuesAffectingPanel() -> Set<String>
    {
        return [ "view", "view.window" ]
    }
    
    @objc open var panel: MINTLCPPanel?
    {
        return self.view.window as? MINTLCPPanel
    }
    
    @objc class func keyPathsForValuesAffectingPanelController() -> Set<String>
    {
        return [ "view",
                 "view.window",
                 "view.window.windowController",
                 "panel",
                 "panel.panelController"]
    }
    
    @objc open var panelController: MINTLCPPanelController?
    {
        return self.panel?.panelController
    }
    
    // MARK: - Utility methods
    
}
