//
//  TECPContentsDataSource.swift
//  TextEditDoc
//
//  Created by narita on 2019/08/22.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

class TECPContentsDataSource: MINTLCPAbstructSource
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods

    // 初期化
    @objc override func launching()
    {
        super.launching()
    }
    
    // 破棄
    @objc override func terminate()
    {
        super.terminate()
    }
    
    @objc override func active()
    {
        super.active()
        
        NSApp.orderedDocuments.forEach()
        {
            if let theDocument = $0 as? TESingleDocument
            {
                // 行ごとに分割
                var theLineNum = 0
                
                theDocument.textStorage?.string.enumerateLines()
                {
                    (line, stop) -> () in
                    
                    let theLocaoLineNum = theLineNum
                    
                    self.sourceItems.append(
                        MINTLCPAbstructSourceItem(description: line,
                                                  action:
                            {
                                theDocument.showWindows()
                                
                                if
                                    let theWindowController = theDocument.windowControllers.first as? TEWindowController,
                                    let theViewController = theWindowController.contentViewController as? TEViewController,
                                    let theTextView = theViewController.textView
                                {
                                    let theRange = theTextView.range(ofLineNumber: theLocaoLineNum)
                                    
                                    theTextView.setSelectedRange(theRange)
                                    theTextView.selectLine(nil)
                                    theTextView.centerSelectionInVisibleArea(nil)
                                }
                                
                            }))
                    
                    theLineNum += 1
                }
            }
        }
    }
    
    // ディアクティブ -> 別スレッドでの検索の中止や、キャッシュの放棄
    @objc override func deactive()
    {
        super.deactive()
    }
    
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    @objc override var groupDisplayName: String
    {
        return NSLocalizedString("Contents", comment: "Contents")
    }

    // kind名: kindで絞り込む時に使う文字列
    @objc override var kindString: String
    {
        return "contents"
    }
}

extension NSTextView
{
    @objc func range(ofLineNumber lineNumber : Int) -> NSRange
    {
        if
            let theLayoutMgr = self.layoutManager
        {
            let theNumOfGlyphs = theLayoutMgr.numberOfGlyphs

            var theNumOfLines = 0
            var theLineRange: NSRange = NSRange()
            var theIndexOfGlyph = 0
            
            while theIndexOfGlyph < theNumOfGlyphs
            {
                theLayoutMgr.lineFragmentRect(forGlyphAt: theIndexOfGlyph,
                                              effectiveRange: &theLineRange)
                
                if theNumOfLines == lineNumber
                {
                    return theLineRange
                }
                
                theIndexOfGlyph = NSMaxRange(theLineRange)
                theNumOfLines += 1
            }
        }
        
        return NSRange()
    }
}
