//
//  TETemplateWindowController.swift
//  CommandPallete
//
//  Created by narita on 2018/11/02.
//  Copyright © 2018 narita. All rights reserved.
//

import Cocoa

class TETemplateWindowController: NSWindowController
{
    // MARK: - class methods
    
    static let gTemplateWindowControllerInstance =
    {
        return TETemplateWindowController()
    }()
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    override func windowDidLoad()
    {
        super.windowDidLoad()
        
        // Implement this method to handle any initialization after your window controller's window has been loaded from its nib file.
        
    }
    
    // MARK: - action methods
    
    func newDocument(ofType typeName: String, withContentsOf contentsURL: URL)
    {
        let theDocumentController = NSDocumentController.shared
        
        do
        {
            let theDocument: NSDocument = try theDocumentController.makeDocument(for: nil ,
                                                                                 withContentsOf: contentsURL,
                                                                                 ofType: typeName)
            
            theDocumentController.addDocument(theDocument)
            theDocument.makeWindowControllers()
            theDocument.showWindows()
        }
        catch
        {
            NSException(
                name: NSExceptionName.invalidArgumentException,
                reason: "\(typeName) is not a recognized document type.").raise()
        }
    }
    
    
    @IBAction func newPlaneTextDocumentFromTemplate01(_ sender: NSObject)
    {
        // 閉じる
        self.window?.performClose(nil)
        
        let theURL: URL = Bundle.main.url(forResource: "PlaneText", withExtension: "txt")!
        
        self.newDocument(ofType: kUTTypePlainText as String, withContentsOf: theURL)
    }
    
    @IBAction func newRTFDocumentFromTemplate01(_ sender: NSObject)
    {
        // 閉じる
        self.window?.performClose(nil)
        
        let theURL: URL = Bundle.main.url(forResource: "RTF", withExtension: "rtf")!
        
        self.newDocument(ofType: kUTTypeRTF as String, withContentsOf: theURL)
    }
    
    @IBAction func newRTFDDocumentFromTemplate01(_ sender: NSObject)
    {
        // 閉じる
        self.window?.performClose(nil)
        
        let theURL: URL = Bundle.main.url(forResource: "RTFD", withExtension: "rtfd")!
        
        self.newDocument(ofType: kUTTypeRTFD as String, withContentsOf: theURL)
    }
    
    @IBAction func newHTMLDocumentFromTemplate01(_ sender: NSObject)
    {
        // 閉じる
        self.window?.performClose(nil)
        
        let theURL: URL = Bundle.main.url(forResource: "HTML", withExtension: "html")!
        
        self.newDocument(ofType: kUTTypeHTML as String, withContentsOf: theURL)
    }
    
    @IBAction func newWebarchiveDocumentFromTemplate01(_ sender: NSObject)
    {
        // 閉じる
        self.window?.performClose(nil)
        
        let theURL: URL = Bundle.main.url(forResource: "Webarchive", withExtension: "webarchive")!
        
        self.newDocument(ofType: kUTTypeWebArchive as String, withContentsOf: theURL)
    }
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    override var document: AnyObject?
        {
        didSet
        {
            self.contentViewController!.representedObject = self.document
        }
    }
    
    override var windowNibName: NSNib.Name
        {
        get
        {
            return NSNib.Name("TETemplateWindowController")
        }
    }
    
    
    // MARK: - Utility methods
    
}
